public class OrderedLinkedList {

    public static final int ASC  = -1; // nodes sorted in ascending order
    public static final int DESC = 1; // nodes sorted in descending order

    int                     order;
    ListNode                head, tail;

    public OrderedLinkedList( int order )
    {
        this.order = order;
        head = tail = null;
    }

    public OrderedLinkedList()
    {
        this( ASC );
    }

    public void reverse()
    {
        // XXX: To Be Implemented
    }

    public OrderedLinkedList merge( OrderedLinkedList other )
    {
        // XXX: To Be Implemented
        return null;
    }

    public int getOrder()
    {
        return order;
    }

    public void insert( Comparable value )
    {
        ListNode newNode = new ListNode( value );

        // empty list
        if( head == null )
        {
            head = tail = newNode;
            return;
        }

        // insert at the beginning, where
        // head.value > value and ASC, or
        // head.value < value and DESC
        if( head.value.compareTo( value ) * order < 0 )
        {
            newNode.next = head;
            head.prev = newNode;
            head = newNode;
            return;
        }

        // insert at the end, where
        // tail.value < value and ASC, or
        // tail.value > value and DESC
        if( value.compareTo( tail.value ) * order < 0 )
        {
            newNode.prev = tail;
            tail.next = newNode;
            tail = newNode;
            return;
        }

        // insert in the middle
        ListNode previous, current;
        previous = current = head;
        while( current != null )
        {
            if( value.compareTo( current.value ) * order < 0 )
            {
                previous = current;
                current = current.next;
            }
            else
            {
                previous.next = newNode;
                current.prev = newNode;
                newNode.next = current;
                newNode.prev = previous;
                return;
            }
        }
    }

    public void print()
    {
        ListNode current = head;
        while( current != null )
        {
            System.out.print( current.value + " " );
            current = current.next;
        }
        System.out.println();
    }

    public static void main( String[] args )
    {
        OrderedLinkedList list1 = new OrderedLinkedList();
        list1.insert( 11 );
        list1.insert( 20 );
        list1.insert( 15 );
        list1.insert( 10 );
        list1.print();

        OrderedLinkedList list2 = new OrderedLinkedList( OrderedLinkedList.DESC );
        list2.insert( 20 );
        list2.insert( 14 );
        list2.insert( 25 );
        list2.insert( 12 );
        list2.print();

/*      
        list1.reverse();
        System.out.println( list1.getOrder() ); // should output 1
        list1.print(); // should output 20 15 11 10

        list2.reverse();
        System.out.println( list2.getOrder() ); // should output -1
        list2.print(); // should output 12 14 20 25

        OrderedLinkedList list3 = list1.merge( list2 );
        list3.print(); // should output 10 11 12 14 15 20 20 25
*/    
    }

}

class ListNode {

    Comparable value;
    ListNode   next, prev;

    ListNode( Comparable value, ListNode next, ListNode prev )
    {
        this.value = value;
        this.next = next;
        this.prev = prev;
    }

    ListNode( Comparable value )
    {
        this( value, null, null );
    }

}
